window.Gleam.initSearch([{"doc":"crabbucket_pgo","title":"crabbucket_pgo","content":"# crabbucket_pgo\n\n[![Package Version](https://img.shields.io/hexpm/v/crabbucket_pgo)](https://hex.pm/packages/crabbucket_pgo)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/crabbucket_pgo/)\n\n```sh\ngleam add crabbucket_pgo@1\n```\n\n## Usage\n\n[The Wisp API example](./examples/wisp_api_limit_example/src/wisp_api_limit_example.gleam)\nshowcases how to use this library with Wisp middleware to apply rate limiting to an API.\n\nFurther documentation can be found at &lt;https://hexdocs.pm/crabbucket_pgo&gt;.\n\n## Development\n\nUnit tests run against a Postgres instance, spun up via `podman-compose`\n\n```sh\nmake test\n```\n","url":"index.html"},{"doc":"crabbucket/pgo","title":"RemainingTokenCountFailure","content":"pub type RemainingTokenCountFailure {\n  MustWaitUntil(next_reset_timestamp: Int)\n  PgoError(error: pgo.QueryError)\n}\n\nMustWaitUntil(next_reset_timestamp: Int)\n\n\nPgoError(error: pgo.QueryError)\n\n\nSynonyms:\ncrabbucket/pgo.RemainingTokenCountFailure\ncrabbucket/pgo RemainingTokenCountFailure","url":"crabbucket/pgo.html#RemainingTokenCountFailure"},{"doc":"crabbucket/pgo","title":"RemainingTokenCountSuccess","content":"pub type RemainingTokenCountSuccess {\n  HasRemainingTokens(\n    remaining_tokens: Int,\n    next_reset_timestamp: Int,\n  )\n}\n\nHasRemainingTokens(\n  remaining_tokens: Int,\n  next_reset_timestamp: Int,\n)\n\n\nSynonyms:\ncrabbucket/pgo.RemainingTokenCountSuccess\ncrabbucket/pgo RemainingTokenCountSuccess","url":"crabbucket/pgo.html#RemainingTokenCountSuccess"},{"doc":"crabbucket/pgo","title":"TokenBucketCleanerMessage","content":"pub type TokenBucketCleanerMessage(msg) {\n  ShutdownTokenBucketCleaner\n  StartTokenBucketCleaner(\n    Subject(TokenBucketCleanerMessage(msg)),\n  )\n  RunTokenBucketCleaner(Subject(TokenBucketCleanerMessage(msg)))\n}\n\nShutdownTokenBucketCleaner\n\n\nStartTokenBucketCleaner(Subject(TokenBucketCleanerMessage(msg)))\n\n\nRunTokenBucketCleaner(Subject(TokenBucketCleanerMessage(msg)))\n\n\nSynonyms:\ncrabbucket/pgo.TokenBucketCleanerMessage\ncrabbucket/pgo TokenBucketCleanerMessage","url":"crabbucket/pgo.html#TokenBucketCleanerMessage"},{"doc":"crabbucket/pgo","title":"TokenBucketCleanerState","content":"pub type TokenBucketCleanerState(key) {\n  TokenBucketCleanerState(\n    conn: Connection,\n    sweep_interval_ms: Int,\n  )\n}\n\nTokenBucketCleanerState(conn: Connection, sweep_interval_ms: Int)\n\n\nSynonyms:\ncrabbucket/pgo.TokenBucketCleanerState\ncrabbucket/pgo TokenBucketCleanerState","url":"crabbucket/pgo.html#TokenBucketCleanerState"},{"doc":"crabbucket/pgo","title":"index_migration_sql","content":"pub const index_migration_sql: String\n\nSynonyms:\ncrabbucket/pgo.index_migration_sql\ncrabbucket/pgo index_migration_sql","url":"crabbucket/pgo.html#index_migration_sql"},{"doc":"crabbucket/pgo","title":"schema_migration_sql","content":"pub const schema_migration_sql: String\n\nSynonyms:\ncrabbucket/pgo.schema_migration_sql\ncrabbucket/pgo schema_migration_sql","url":"crabbucket/pgo.html#schema_migration_sql"},{"doc":"crabbucket/pgo","title":"table_migration_sql","content":"pub const table_migration_sql: String\n\nSynonyms:\ncrabbucket/pgo.table_migration_sql\ncrabbucket/pgo table_migration_sql","url":"crabbucket/pgo.html#table_migration_sql"},{"doc":"crabbucket/pgo","title":"create_and_start_cleaner","content":"pub fn create_and_start_cleaner(\n  conn: Connection,\n  sweep_interval_ms: Int,\n) -&gt; Subject(TokenBucketCleanerMessage(a))\n Having our token buckets in a database table means there&#39;s going to be\n cruft left behind.\n To mitigate this, a TokenBucketCleaner is an actor which periodically executes\n a SQL command to purge expired buckets.\n \n `sweep_interval_ms` describes how often the script should run,\n in milliseconds.\n \n The cleaner deletes 1,000-record segments at a time to help avoid writer\n contention in the database, and is hard-coded to only delete up to\n 10 segments (10,000 records) at a time,\n to avoid holding onto a pool connection for too long.\nSynonyms:\ncrabbucket/pgo.create_and_start_cleaner\ncrabbucket/pgo create_and_start_cleaner","url":"crabbucket/pgo.html#create_and_start_cleaner"},{"doc":"crabbucket/pgo","title":"handle_cleaner_message","content":"pub fn handle_cleaner_message(\n  message: TokenBucketCleanerMessage(a),\n  state: TokenBucketCleanerState(b),\n) -&gt; Next(\n  TokenBucketCleanerMessage(a),\n  TokenBucketCleanerState(b),\n)\n\nSynonyms:\ncrabbucket/pgo.handle_cleaner_message\ncrabbucket/pgo handle_cleaner_message","url":"crabbucket/pgo.html#handle_cleaner_message"},{"doc":"crabbucket/pgo","title":"remaining_tokens_for_key","content":"pub fn remaining_tokens_for_key(\n  conn: Connection,\n  key: String,\n  window_duration_ms: Int,\n  default_tokens: Int,\n) -&gt; Result(\n  RemainingTokenCountSuccess,\n  RemainingTokenCountFailure,\n)\n Takes an arbitrary key and window duration, inserting a record if non-existing.\n \n Suggestion: you may wish to format your key such that it indicates\n usage / purpose, value type, and value.\n For instance, if you&#39;re limiting a specific endpoint for a given user,\n the key might look something like:\n `some_endpoint_name:user:12345`\n \n `window_duration_milliseconds` describes the length of the time window\n valid for a number of tokens.\n For instance, a value of 1,000 with a default token count of 100 would mean\n an action could occur 100 times per second.\n \n Return should be either\n `HasRemainingTokens(remaining_tokens: Int, next_reset_timestamp: Int)`,\n which indicates that an action may proceed and contains how many more times\n the action may occur with the current window,\n or it may be `MustWaitUntil(next_reset_timestamp: Int)`,\n which indicates that no tokens remain for this key and the next Unix\n timestamp (in milliseconds) that the client must wait for.\nSynonyms:\ncrabbucket/pgo.remaining_tokens_for_key\ncrabbucket/pgo remaining_tokens_for_key","url":"crabbucket/pgo.html#remaining_tokens_for_key"},{"doc":"crabbucket/pgo","title":"crabbucket/pgo","content":"","url":"crabbucket/pgo.html"}]);